Merge branch 'master' of ssh://git.indexdata.com/home/git/pub/idzebra
[idzebra-moved-to-github.git] / debian / idzebra-2.0-utils.zebrasrv.init
1 #! /bin/sh
2 ### BEGIN INIT INFO
3 # Provides:          zebrasrv
4 # Required-Start:    $local_fs $remote_fs $network $named $time
5 # Required-Stop:     $local_fs $remote_fs
6 # Default-Start:     2 3 4 5
7 # Default-Stop:      0 1 6
8 # Short-Description: Controls the zebrasrv daemon
9 # Description:       Controls the IDZebra server daemon
10 #                    /usr/bin/zebrasrv-2.0 .
11 ### END INIT INFO
12
13 # Do NOT "set -e"
14
15 # PATH should only include /usr/* if it runs after the mountnfs.sh script
16 PATH=/sbin:/usr/sbin:/bin:/usr/bin
17 NAME=zebrasrv
18 DAEMON=/usr/bin/$NAME
19 DAEMON_OPTS="-l /var/log/zebrasrv.log -u nobody tcp:@6:2100"
20 PIDFILE=/var/run/$NAME.pid
21 SCRIPTNAME=/etc/init.d/$NAME
22 CONFIG=/etc/idzebra/zebra.cfg
23
24 # Exit if the package is not installed
25 [ -x "$DAEMON" ] || exit 0
26
27 # Read configuration variable file if it is present
28 [ -r /etc/default/$NAME ] && . /etc/default/$NAME
29
30 # If no CONFIG, bail out
31 [ -r $CONFIG ] || exit 0
32
33 # Load the VERBOSE setting and other rcS variables
34 . /lib/init/vars.sh
35
36 # Define LSB log_* functions.
37 # Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
38 . /lib/lsb/init-functions
39
40 #
41 # Function that starts the daemon/service
42 #
43 do_start()
44 {
45         # Return
46         #   0 if daemon has been started
47         #   1 if daemon was already running
48         #   2 if daemon could not be started
49         start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
50                 || return 1
51         start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON -- \
52                 $DAEMON_OPTS -D -c $CONFIG -p $PIDFILE \
53                 || return 2
54         # Add code here, if necessary, that waits for the process to be ready
55         # to handle requests from services started subsequently which depend
56         # on this one.  As a last resort, sleep for some time.
57 }
58
59 #
60 # Function that stops the daemon/service
61 #
62 do_stop()
63 {
64         # Return
65         #   0 if daemon has been stopped
66         #   1 if daemon was already stopped
67         #   2 if daemon could not be stopped
68         #   other if a failure occurred
69         start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
70         RETVAL="$?"
71         [ "$RETVAL" = 2 ] && return 2
72         # Wait for children to finish too if this is a daemon that forks
73         # and if the daemon is only ever run from this initscript.
74         # If the above conditions are not satisfied then add some other code
75         # that waits for the process to drop all resources that could be
76         # needed by services started subsequently.  A last resort is to
77         # sleep for some time.
78         #start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
79         #[ "$?" = 2 ] && return 2
80         # Many daemons don't delete their pidfiles when they exit.
81         rm -f $PIDFILE
82         return "$RETVAL"
83 }
84
85 #
86 # Function that sends a SIGHUP to the daemon/service
87 #
88 do_reload() {
89         #
90         # If the daemon can reload its configuration without
91         # restarting (for example, when it is sent a SIGHUP),
92         # then implement that here.
93         #
94         start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
95         return 0
96 }
97
98 case "$1" in
99   start)
100         [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
101         do_start
102         case "$?" in
103                 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
104                 2) [ "$VERBOSE" = no ] && \
105                                 log_daemon_msg "Starting $DESC" "$NAME"
106                         log_end_msg 1 
107                 ;;
108         esac
109         ;;
110   stop)
111         [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
112         do_stop
113         case "$?" in
114                 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
115                 2) [ "$VERBOSE" = no ] && \
116                                 log_daemon_msg "Stopping $DESC" "$NAME"
117                         log_end_msg 1 
118                 ;;
119         esac
120         ;;
121   #reload|force-reload)
122         #
123         # If do_reload() is not implemented then leave this commented out
124         # and leave 'force-reload' as an alias for 'restart'.
125         #
126         #log_daemon_msg "Reloading $DESC" "$NAME"
127         #do_reload
128         #log_end_msg $?
129         #;;
130   restart|force-reload)
131         #
132         # If the "reload" option is implemented then remove the
133         # 'force-reload' alias
134         #
135         log_daemon_msg "Restarting $DESC" "$NAME"
136         do_stop
137         case "$?" in
138           0|1)
139                 do_start
140                 case "$?" in
141                         0) log_end_msg 0 ;;
142                         1) log_end_msg 1 ;; # Old process is still running
143                         *) log_end_msg 1 ;; # Failed to start
144                 esac
145                 ;;
146           *)
147                 # Failed to stop
148                 log_end_msg 1
149                 ;;
150         esac
151         ;;
152   *)
153         #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
154         echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
155         exit 3
156         ;;
157 esac
158
159 :